// OPS JavaScript AAJX Source 
var accessToken;
// var uribaseoData = "https://api.businesscentral.dynamics.com/v2.0/5fd6d3e1-b80a-48ca-a8a8-afa0b0d12f4e/Production/ODataV4/Company('CRONUS%20USA%2C%20Inc.')/";
// var uribaseAPI = "https://api.businesscentral.dynamics.com/v2.0/5fd6d3e1-b80a-48ca-a8a8-afa0b0d12f4e/Production/api/v2.0/companies(c4c1f6b5-5896-ec11-bb88-6045bd8b19aa)/";
// var uritoken = "https://prod-08.westus.logic.azure.com:443/workflows/4975ad160d6d46768b3de6a620e90551/triggers/manual/paths/invoke?api-version=2016-06-01&sp=%2Ftriggers%2Fmanual%2Frun&sv=1.0&sig=ZAZapwktdXtQ8ZE_HI4XWAH000RPKLImQnDIDaz2Te8";
// var uribaseoData = apiurl;
$(document).ready(function(){
    var activeAjaxCount = 0;

    $( document ).ajaxStart(function() {
        activeAjaxCount++;
        $("#preloader").show();
    });

    $( document ).ajaxComplete(function() {
        activeAjaxCount--;
        if (activeAjaxCount <= 3) {
            $("#preloader").hide();
        }
    });
});
function fetchinfo(query, iscommon = false, mode = "", uriReq = false, method = "", etag = "") {
    query = filterQuery(query);
    var type = "Fetch";
    accessTok(query, iscommon, mode, "", "", type, uriReq, method, etag);
}

function processFetchInfo(query, iscommon, mode, accessToken, api = false ,method, etag) {
    uri = (api ? uribaseAPI : uribaseoData) + query;
    if(method == ""){
        method = "GET";
    }
    $.ajax({
        type: method,
        url: uri,
        beforeSend: function(xhr){
            xhr.setRequestHeader('Authorization', 'Bearer ' +accessToken);
            if(etag !== ""){
                xhr.setRequestHeader('If-Match', etag);
            }    
        },
        success: function (json_data) {
            try {
                if(json_data !== undefined){
                    $("#apiResponse").html(JSON.stringify(json_data));
                    myObj = json_data.value; //JSON.parse(json_data);
                    if (iscommon || mode == "CURR") {
                        fetchDataCommon(myObj);
                    }
                    else if (mode == "POSTCOMMENT") {
                        postComment(myObj);
                    }
                    else if (mode == "GETCOMMENT") {
                        getComment(myObj);
                    }
                    else if (mode == "GETDOCUMENTS") {
                        getDocuments(myObj);
                    }
                    else if (mode == "GETORDER") {
                        getOrder(json_data);
                    }
                    else if (mode == "GETORDERLINE") {
                        getOrderLine(json_data);
                    }
                    else if (mode == "GETETAG") {
                        getEtag(json_data);
                    }
                    else if (mode == "ITEMDETAIL") {
                        getItemEtag(json_data);
                    }
                    else if (mode == "GETDOCNO") {
                        getDocNo(json_data);
                    }
                    else {
                        fetchData(myObj);
                    }
                }else{
                    refreshTableData();
                }
                
                // $("#preloader").hide(); 
            }
            catch (err) {
                console.log(err);
                // $("#preloader").hide();
                showError(err.responseText, false);
            }
        },
        // In case of error, show an alert
        error: function (err) {
            if (mode == "ADDORDERLINE" || mode == "UPDATEORDERLINE" || method == "DELETE") {
                errorMsg(err);;
            }else{
                showError(err.responseText, false);
            }
            console.log(err);
        }
    })
}

function postInfo(mode = "", query, content, uriReq = false, method = "", etag = "", batch = false) {
    var type = "Post";
    query = filterQuery(query);
    accessTok(query, false, mode, content, "", type, uriReq, method, etag, batch);
}

function processPostInfo(mode, query, content, accessToken, api = false, method, etag, batch = false) {
    uri = (api ? uribaseAPI : uribaseoData);
    uri = (batch ? batchAPI : uri) ;
    uri = uri + query;
    method = ((method !== "") ? method : "POST");
    $.ajax({
        type: method,
        url: uri,
        data: content,
        contentType: "application/json",
        dataType: 'json',
        beforeSend: function(xhr){
            xhr.setRequestHeader('Authorization', 'Bearer ' +accessToken);
            if(etag !== ""){
                xhr.setRequestHeader('If-Match', etag);
            }    
        },
        success: function (json_data) {
            try {
                $("#apiResponse").html(JSON.stringify(json_data));
                myObj = json_data.value; //JSON.parse(json_data);
                if (mode == "COMMENT") {
                    commentAdded(myObj);
                }
                else if (mode == "ADDORDER") {
                    addOrder(json_data);
                }
                else if (mode == "ADDORDERLINE") {
                    refreshTableData();
                }
                else if (mode == "UPLOADDOC") {
                    postFile(json_data);
                }
                else if (mode == "GETDOCUMENTS") {
                    getDocuments(json_data);
                }else if (mode == "UPDATEORDERLINE") {
                    updateOrder(json_data);
                }else if (mode == "BATCHJOB") {
                    batchJob(json_data);
                }
                // $("#preloader").hide();
            }
            catch (err) {
                console.log(err);
                showError(err.responseText, false);
            }
        },
        error: function (err) {
            if (mode == "ADDORDERLINE" || mode == "UPDATEORDERLINE" || method == "DELETE") {
                errorMsg(err);;
            }else{
                showError(err.responseText, false);
            }
            console.log(err);
        }
    })
}

function DownloadFile(query, mode = "", filename = "", uriReq = false) {
    var type = "Download";
    query = filterQuery(query);
    accessTok(query, false, mode, "", filename, type, uriReq);
}

function processDownloadFile(query, mode, filename, accessToken, api = false) {
    uri = (api ? uribaseAPI : uribaseoData) + query;

    $.ajax({
        type: 'POST',
        url: uri,
        headers: {
            "Authorization": "Bearer " + accessToken
        },
        success: function (json_data) {
            try {
                $("#apiResponse").html(JSON.stringify(json_data));
                myObj = json_data.value; //JSON.parse(json_data);
                if (mode == "DOWNLOADDOCUMENTS") {
                    if (myObj) {
                        var mimeType = "application/pdf";
                        var ext = filename.substr(filename.lastIndexOf('.') + 1);

                        // switch (ext) {
                        //     case "png":
                        //         mimeType = "image/png"
                        //     case "jpg":
                        //         mimeType = "image/jpg"
                        // }

                        var anchor = document.createElement('a');
                        anchor.href = "data:" + ext + ";base64," + myObj;
                        anchor.target = '_blank';
                        anchor.download = filename;
                        anchor.click();
                    }
                }
            }
            catch (err) {
                showError("Error: " + err.responseText, false);
                console.log(err);
            }
            // $("#preloader").hide();
        },
        // In case of error, show an alert
        error: function (err) {
            showError(err.responseText, false);
            console.log(err);
        }
    })
}

function accessTok(query, iscommon, mode, content, filename, type, uriReq, method, etag, batch = false) {
    // var accessToken;
    if(accessToken == undefined){
        $.ajax({
            type: 'GET',
            url: tokenurl,
            dataType: 'json',
            crossDomain: true,
            success: function (json_data) {
                try {
                    // $("#preloader").show();
                    accessToken = json_data["token"];
                    if (type == "Fetch")
                        processFetchInfo(query, iscommon, mode, accessToken, uriReq, method, etag);
                    else if (type == "Post")
                        processPostInfo(mode, query, content, accessToken, uriReq, method, etag, batch);
                    else if (type == "Download")
                        processDownloadFile(query, mode, filename, accessToken, uriReq);
                    else if (type == "PATCH")
                        processUploadFile(query, iscommon, mode, content, accessToken, uriReq, etag);
                }
                catch (err) {
                    console.log(err);
                    alert(err.responseText);
                }
            },
            error: function (err) {
                console.log(err);
                alert(err.responseText);
            }
        })
    }else{
        if (type == "Fetch"){
            processFetchInfo(query, iscommon, mode, accessToken, uriReq, method, etag);
        }
        else if (type == "Post"){
            processPostInfo(mode, query, content, accessToken, uriReq, method, etag, batch);
        }
        else if (type == "Download"){
            processDownloadFile(query, mode, filename, accessToken, uriReq);
        }
        else if (type == "PATCH"){
            processUploadFile(query, iscommon, mode, content, accessToken, uriReq, etag);
        }
    }
        
}

function processUploadFile(query, iscommon, mode, content, accessToken, api, etag){
    uri = (api ? uribaseAPI : uribaseoData) + query;
    
    var xhr = new XMLHttpRequest();
    xhr.withCredentials = true;

    xhr.addEventListener("readystatechange", function() {
        if(this.readyState === 4) {
            console.log(this.responseText);
        }
    });
    
    xhr.open("PATCH", uri);
    xhr.setRequestHeader("If-Match", etag);
    xhr.setRequestHeader("Authorization", "Bearer " + accessToken);

    xhr.send(content);
    $("#success-msz").show('slow');
    setTimeout(function(){ $("#success-msz").hide('slow'); }, 5000);
    // $("#preloader").hide();
    refreshDocuments();
}

function uploadDocument(query, etag = "", mode = "", content, uriReq = false, method = "") {
    var type = "PATCH";
    query = filterQuery(query);
    accessTok(query, false, mode, content, "", type, uriReq, method, etag);
}

function filterQuery(query){
    var response = query.replace('{','');
    response = response.replace('}','');
    return response;
}